
#ifndef _NPC_H
#define _NPC_H

#include "world_entity.h"
#include "ai_module.h"
#include "world_entities/weapons/weapon_manager.h"

class AI;

class NPC : public WorldEntity
{
  ObjectListDeclaration(NPC);

public:
  NPC(const TiXmlElement* root = NULL);
  virtual ~NPC ();

  virtual void loadParams(const TiXmlElement* root = NULL);

  virtual void tick(float dt);
  inline int getTeam()  { return teamNumber; }


private:
  inline void setTeamNumber(int number) { teamNumber=number; }
  inline void setSwarmNumber(int number) { swarmNumber=number; }


 private:

  int                   teamNumber;   //!< number of the team
  int                   swarmNumber;  //!< number of the swarm
  int                   difficulty;   //!< difficulty

  WeaponManager         weaponMan;    //!< weapon manager
  bool                  bFire;        //!< fire

  AIModule*             aiModule;
};

#endif /* _NPC_H */
